import 'package:carousel_slider/carousel_slider.dart';
import 'package:flutter/material.dart';

//sagar khemnar

// ignore: must_be_immutable
class DottedCarasoulSlider extends StatefulWidget {
  // add a image list inside a imgurls
  final List<String>? imgUrls;

  //set a duration for get skiping  the slide
  final Duration? duration;

  //set a height for a image
  final double? height;

  //set a width for a image
  final double? width;

  //if you want to show a dots then  make it true otherwise its false
  final bool showDots;

  //if you want to autoplay then  make it true otherwise its false
  final bool? autoplay;

  //if you want to reverse then  make it true otherwise its false
  final bool? reverse;

  //when showArrows get true then we can give a size for a icons
  final double? iconSize;

  //we can set a color when dot is activate
  final Color? dotActiveColor;

  //we can set a color when dot is deactivate
  final Color? dotInActiveColor;

  //we can give a aspect ratio by the device
  final double? aspectRatio;

  //if we want to show a arrows then we make a showArrows to true otherwise it false
  final bool? showArrows;

  // if we want to add a left icon
  final IconData? lefticon;

  // if we want to add a right icon
  final IconData? righticon;

  // if we want to add a  iconColor
  final Color? iconColor;

  final double? dotDirectionTop;
  final double? dotDirectionBottom;
  final double? dotDirectionLeft;
  final double? dotDirectionRight;
  final BoxFit? fit;
  const DottedCarasoulSlider(
      {Key? key,
      required this.imgUrls,
      this.duration,
      this.autoplay,
      this.reverse,
      this.fit,
      this.showArrows,
      this.aspectRatio,
      this.dotActiveColor,
      this.dotInActiveColor,
      this.lefticon,
      this.righticon,
      this.iconColor,
      this.iconSize,
      this.dotDirectionBottom,
      this.dotDirectionLeft,
      this.dotDirectionRight,
      this.dotDirectionTop,
      required this.height,
      required this.width,
      required this.showDots})
      : super(key: key);

  @override
  State<DottedCarasoulSlider> createState() => _DottedCarasoulsliderState();
}

class _DottedCarasoulsliderState extends State<DottedCarasoulSlider> {
  int _currentSlide = 0;
  final CarouselController _carouselController = CarouselController();

//function when show arrows is true then condition is working
  void nextPage() {
    _carouselController.nextPage();
  }

//function when show arrows is true then condition is working
  void previousPage() {
    _carouselController.previousPage();
  }

  @override
  Widget build(BuildContext context) {
    return Column(
      children: [
        Stack(
          alignment: Alignment.center,
          children: [
            CarouselSlider.builder(
              itemCount: widget.imgUrls?.length ?? 0,
              carouselController: _carouselController,
              itemBuilder: (context, index, realIndex) {
                return SizedBox(
                  height: widget.height,
                  width: widget.width,
                  child: Image.network(widget.imgUrls!.elementAt(index), fit:widget.fit ,),
                );
              },
              options: CarouselOptions(
                aspectRatio: widget.aspectRatio ?? 16 / 9,
                reverse: widget.reverse ?? false,
                autoPlay: widget.autoplay ?? false,
                autoPlayInterval: widget.duration ?? const Duration(seconds: 0),
                onPageChanged: (index, _) {
                  setState(() {
                    _currentSlide = index;
                  });
                },
              ),
            ),
            if ((widget.dotDirectionTop != null ||
                    widget.dotDirectionLeft != null ||
                    widget.dotDirectionBottom != null ||
                    widget.dotDirectionRight != null) &&
                widget.showArrows == true)
              Positioned(
                top: widget.dotDirectionTop,
                left: widget.dotDirectionLeft,
                bottom: widget.dotDirectionBottom,
                right: widget.dotDirectionRight,
                child: Row(
                  mainAxisAlignment: MainAxisAlignment.center,
                  crossAxisAlignment: CrossAxisAlignment.end,
                  children: List.generate(
                    widget.imgUrls?.length ?? 0,
                    (index) => GestureDetector(
                      onTap: () {
                        setState(() {
                          _currentSlide = index;
                        });
                      },
                      child: Container(
                        width: 8.0,
                        height: 8.0,
                        margin: const EdgeInsets.symmetric(
                            vertical: 10.0, horizontal: 2.0),
                        decoration: BoxDecoration(
                          shape: BoxShape.circle,
                          color: _currentSlide == index
                              ? widget.dotActiveColor ?? Colors.blue
                              : widget.dotInActiveColor ?? Colors.grey,
                        ),
                      ),
                    ),
                  ),
                ),
              )
          ],
        ),
        if (widget.showDots == true)
          Row(
            mainAxisAlignment: MainAxisAlignment.center,
            children: List.generate(
              widget.imgUrls?.length ?? 0,
              (index) => GestureDetector(
                onTap: () {
                  setState(() {
                    _currentSlide = index;
                  });
                },
                child: Container(
                  width: 8.0,
                  height: 8.0,
                  margin: const EdgeInsets.symmetric(
                      vertical: 10.0, horizontal: 2.0),
                  decoration: BoxDecoration(
                    shape: BoxShape.circle,
                    color: _currentSlide == index
                        ? widget.dotActiveColor ?? Colors.blue
                        : widget.dotInActiveColor ?? Colors.grey,
                  ),
                ),
              ),
            ),
          )
      ],
    );
  }
}
